Unit QSK2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure QSK2R(FUN :Func_F1; A :Real; B :Real; ABSERR :Real;
                RELERR :Real; var RESULT_ :Real; var ERREST :Real;
                var NOFUN :Integer; var FLAG :Real);

implementation

procedure QSK2R(FUN :Func_F1; A :Real; B :Real; ABSERR :Real;
                RELERR :Real; var RESULT_ :Real; var ERREST :Real;
                var NOFUN :Integer; var FLAG :Real);
var
LEVMIN,LEVMAX,LEVOUT,NOMAX,NOFIN,LEV,NIM,I,J :Integer;
W0,W1,W2,W3,W4,AREA,X0,F0,STONE,STEP,COR11,TEMP,QPREV,QNOW,QDIFF,
   QLEFT,ESTERR,TOLERR :Real;
QRIGHT :Array [0..30] of Real;
F :Array [0..15] of Real;
X :Array [0..15] of Real;
FSAVE :Array [0..239] of Real;
XSAVE :Array [0..239] of Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin


{    SI  INGRL F FUN() FR    }
{      USR RVIDD LRN. }
{    N UI DIV RUIN SD N }
{     8-NL NWN-S RUL. }

{    INU .. }

{    FUN      N F  INGRND FUNIN SURGR FUN(). }
{            LWR LII F INGRIN. }
{            UR LII F INGRIN.(   LSS N .) }
{    RLRR   RLIV RRR LRN. (SULD  NN-NGIV) }
{    SRR  N SLU RRR LRN. (SULD  NN-NGIV) }

{    UU .. }

{    RSUL  N RIIN   INGRL FULL SISFING  }
{            LS SRINGN F  W RRR LRNS. }
{    RRS  N SI F  GNIUD F  UL RRR. }
{    NFUN    NUR F FUNIN VLUS USD IN LULIN F RSUL. }
{    FLG     RLIILI INDIR.  IF FLG IS ZR, N RSUL }
{            RL SISFIS  RRR LRN.  IF FLG IS }
{            . , N   =  NUR F INRVLS WI V }
{            N NVRGD ND  . =  FRIN F  INRVL }
{            LF  D WN  LII N  NFUN  WS RD. }


{    ***   SG 1 ***   GNRL INIILIZIN }
{    S NSNS. }

for I:=1 to 16 do
 begin
  X[I-1] := 0.0;
  F[I-1] := 0.0;
 end;
for I:=1 to 240 do
 begin
  XSAVE[I-1] := 0.0;
  FSAVE[I-1] := 0.0;
 end;
for I:=1 to 31 do
 QRIGHT[I-1] := 0.0;

LEVMIN := 1;
LEVMAX := 30;
LEVOUT := 6;
NOMAX := 5000;
NOFIN := NOMAX-8*(LEVMAX-LEVOUT+Trunc(Power(2,LEVOUT+1)));

{    RUL WN NFUN RS NFIN }

W0 := 3956.0/14175.0;
W1 := 23552.0/14175.0;
W2 := -3712.0/14175.0;
W3 := 41984.0/14175.0;
W4 := -18160.0/14175.0;

{    INIILIZ RUNNING SUS  ZR. }

FLAG := 0.0;
RESULT_ := 0.0;
COR11 := 0.0;
ERREST := 0.0;
AREA := 0.0;
NOFUN := 0;
if ( A  = B ) 
 then goto _15;

{    ***   SG 2 ***   INIILIZIN FR FIRS INRVL }

LEV := 0;
NIM := 1;
X0 := A;
X[15] := B;
QPREV := 0.0;
F0 := FUN(X0);
STONE := (B-A)/16.0;
X[7] := (X0+X[15])/2.0;
X[3] := (X0+X[7])/2.0;
X[11] := (X[7]+X[15])/2.0;
X[1] := (X0+X[3])/2.0;
X[5] := (X[3]+X[7])/2.0;
X[9] := (X[7]+X[11])/2.0;
X[13] := (X[11]+X[15])/2.0;
J := 2;
while ( J<=16 ) do
 begin
  F[J-1] := FUN(X[J-1]);
_1:
  inc(J,2);
 end;
NOFUN := 9;

{    ***   SG 3 ***   NRL LULIN }
{    RQUIRS QRV,,2,4,...,16,F,F2,F4,...,F16. }
{    LULS 1,3,...15, F1,F3,...F15,QLF,QRIG,QNW,QDIFF,R. }

_2:
X[0] := (X0+X[1])/2.0;
F[0] := FUN(X[0]);
J := 3;
while ( J<=15 ) do
 begin
  X[J-1] := (X[J-2]+X[J+0])/2.0;
  F[J-1] := FUN(X[J-1]);
_3:
  inc(J,2);
 end;
NOFUN := NOFUN+8;
STEP := (X[15]-X0)/16.0;
QLEFT := (W0*(F0+F[7])+W1*(F[0]+F[6])+W2*(F[1]+F[5])+W3*(F[2]+F[4])+
    W4*F[3])*STEP;
QRIGHT[LEV+0] := (W0*(F[7]+F[15])+W1*(F[8]+F[14])+W2*(F[9]+F[13])+
    W3*(F[10]+F[12])+W4*F[11])*STEP;
QNOW := QLEFT+QRIGHT[LEV+0];
QDIFF := QNOW-QPREV;
AREA := AREA+QDIFF;

{    ***   SG 4 *** INRVL NVRGN S }

ESTERR := Abs(QDIFF)/1023.0;
TOLERR := EMax1(ABSERR,RELERR*Abs(AREA))*(STEP/STONE);
if ( LEV  < LEVMIN )
 then goto _4;
if ( LEV  >= LEVMAX )
 then goto _8;
if ( NOFUN  > NOFIN )
 then goto _7;
if ( ESTERR  <= TOLERR ) 
 then goto _9;

{    ***   SG 5   ***   N NVRGN }
{    L N INRVL. }

_4:
NIM := 2*NIM;
LEV := LEV+1;

{    SR RIG ND LNS FR FUUR US. }

for I:=1 to 8 do
 begin
  FSAVE[(I-1)+(LEV-1)*8] := F[I+7];
  XSAVE[(I-1)+(LEV-1)*8] := X[I+7];
_5:
 end;

{    SSL LF ND LNS FR IDI US. }

QPREV := QLEFT;
for I:=1 to 8 do
 begin
  J := -I;
  F[2*J+17] := F[J+8];
  X[2*J+17] := X[J+8];
_6:
 end;
goto _2;

{    ***   SG 6   ***   RUL SIN }
{    NUR F FUNIN VLUS IS U  D LII. }

_7:
NOFIN := 2*NOFIN;
LEVMAX := LEVOUT;
FLAG := FLAG+(B-X0)/(B-A);
goto _9;

{    URRN LVL IS LV. }

_8:
FLAG := FLAG+1.0;

{    ***   SG 7   ***   INRVL NVRGD }
{    DD NRIUINS IN RUNNING SUS. }

_9:
RESULT_ := RESULT_+QNOW;
ERREST := ERREST+ESTERR;
COR11 := COR11+QDIFF/1023.0;

{    L N INRVL. }

_10:
//if ( NIM  = 2*(NIM/2) )
if ( NIM  mod 2 =0 )  {  }
 then goto _11;
NIM := NIM div 2;
LEV := LEV-1;
goto _10;
_11:
NIM := NIM+1;
if ( LEV  <= 0 )
 then goto _13;

{    SSL LNS RQUIRD FR  N INRVL. }

QPREV := QRIGHT[LEV-1];
X0 := X[15];
F0 := F[15];
for I:=1 to 8 do
 begin
  F[2*I-1] := FSAVE[(I-1)+(LEV-1)*8];
  X[2*I-1] := XSAVE[(I-1)+(LEV-1)*8];
_12:
 end;
goto _2;

{    ***   SG 8   ***   FINLIZ ND RURN }

_13:
RESULT_ := RESULT_+COR11;

{     SUR RRS N LSS N RUNDFF LVL. }

if ( ERREST  = 0.0 ) 
 then goto _15;
_14:
TEMP := Abs(RESULT_)+ERREST;
if ( TEMP  <> Abs(RESULT_) ) 
 then goto _15;
ERREST := 2.0*ERREST;
goto _14;
_15:
end;

end.
